searchNodes=[{"ref":"K8s.html","title":"K8s","type":"module","doc":"Kubernetes API Client for Elixir"},{"ref":"K8s.Client.html","title":"K8s.Client","type":"module","doc":"An experimental k8s client. Functions return K8s.Operations that represent kubernetes operations. To run operations pass them to: run/2, run/3, or run/4. When specifying kinds the format should either be in the literal kubernetes kind name (eg &quot;ServiceAccount&quot;) or the downcased version seen in kubectl (eg &quot;serviceaccount&quot;). A string or atom may be used. Examples &quot;Deployment&quot;, &quot;deployment&quot;, :Deployment, :deployment &quot;ServiceAccount&quot;, &quot;serviceaccount&quot;, :ServiceAccount, :serviceaccount &quot;HorizontalPodAutoscaler&quot;, &quot;horizontalpodautoscaler&quot;, :HorizontalPodAutoscaler, :horizontalpodautoscaler opts to K8s.Client.Runner modules are HTTPoison HTTP option overrides."},{"ref":"K8s.Client.html#async/2","title":"K8s.Client.async/2","type":"function","doc":"alias of K8s.Client.Runner.Async.run/3"},{"ref":"K8s.Client.html#async/3","title":"K8s.Client.async/3","type":"function","doc":"alias of K8s.Client.Runner.Async.run/3"},{"ref":"K8s.Client.html#create/1","title":"K8s.Client.create/1","type":"function","doc":"Returns a POST K8s.Operation to create the given resource. Examples iex&gt; deployment = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Deployment&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; }, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;test&quot; ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;replicas&quot; =&gt; 2, ...&gt; &quot;selector&quot; =&gt; %{ ...&gt; &quot;matchLabels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;template&quot; =&gt; %{ ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;containers&quot; =&gt; %{ ...&gt; &quot;image&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; K8s.Client.create(deployment) %K8s.Operation{ method: :post, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;], verb: :create, api_version: &quot;apps/v1&quot;, name: &quot;Deployment&quot;, data: %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; }, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;test&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 2, &quot;selector&quot; =&gt; %{ &quot;matchLabels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; %{ &quot;image&quot; =&gt; &quot;nginx&quot;, &quot;name&quot; =&gt; &quot;nginx&quot; } } } } } }"},{"ref":"K8s.Client.html#create/2","title":"K8s.Client.create/2","type":"function","doc":"Returns a POST K8s.Operation to create the given subresource. Used for creating subresources like Scale or Eviction. Examples Eviction a pod iex&gt; pod = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;v1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Pod&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;default&quot; ...&gt; } ...&gt; } ...&gt; eviction = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;policy/v1beta1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Eviction&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;default&quot; ...&gt; } ...&gt; } ...&gt; K8s.Client.create(pod, eviction) %K8s.Operation{api_version: &quot;v1&quot;, data: %{&quot;apiVersion&quot; =&gt; &quot;policy/v1beta1&quot;, &quot;kind&quot; =&gt; &quot;Eviction&quot;, &quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;default&quot;}}, method: :post, name: {&quot;Pod&quot;, &quot;Eviction&quot;}, path_params: [namespace: &quot;default&quot;, name: &quot;nginx&quot;], verb: :create}"},{"ref":"K8s.Client.html#create/4","title":"K8s.Client.create/4","type":"function","doc":"Returns a POST K8s.Operation to create the given subresource. Used for creating subresources like Scale or Eviction. Examples Eviction a pod iex&gt; eviction = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;policy/v1beta1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Eviction&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;default&quot; ...&gt; } ...&gt; } ...&gt; K8s.Client.create(&quot;v1&quot;, &quot;pods/eviction&quot;, [namespace: &quot;default&quot;, name: &quot;nginx&quot;], eviction) %K8s.Operation{api_version: &quot;v1&quot;, data: %{&quot;apiVersion&quot; =&gt; &quot;policy/v1beta1&quot;, &quot;kind&quot; =&gt; &quot;Eviction&quot;, &quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;default&quot;}}, method: :post, name: &quot;pods/eviction&quot;, path_params: [namespace: &quot;default&quot;, name: &quot;nginx&quot;], verb: :create}"},{"ref":"K8s.Client.html#delete/1","title":"K8s.Client.delete/1","type":"function","doc":"Returns a DELETE operation for a resource by manifest. May be a partial manifest as long as it contains: apiVersion kind metadata.name metadata.namespace (if applicable) K8s Docs: Delete will delete a resource. Depending on the specific resource, child objects may or may not be garbage collected by the server. See notes on specific resource objects for details. Examples iex&gt; deployment = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Deployment&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; }, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;test&quot; ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;replicas&quot; =&gt; 2, ...&gt; &quot;selector&quot; =&gt; %{ ...&gt; &quot;matchLabels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;template&quot; =&gt; %{ ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;containers&quot; =&gt; %{ ...&gt; &quot;image&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; K8s.Client.delete(deployment) %K8s.Operation{ method: :delete, verb: :delete, api_version: &quot;apps/v1&quot;, name: &quot;Deployment&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;] }"},{"ref":"K8s.Client.html#delete/3","title":"K8s.Client.delete/3","type":"function","doc":"Returns a DELETE operation for a resource by version, kind, name, and optionally namespace. Examples iex&gt; K8s.Client.delete(&quot;apps/v1&quot;, &quot;Deployment&quot;, namespace: &quot;test&quot;, name: &quot;nginx&quot;) %K8s.Operation{ method: :delete, verb: :delete, api_version: &quot;apps/v1&quot;, name: &quot;Deployment&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;] }"},{"ref":"K8s.Client.html#delete_all/2","title":"K8s.Client.delete_all/2","type":"function","doc":"Returns a DELETE collection operation for all instances of a cluster scoped resource kind. Examples iex&gt; K8s.Client.delete_all(&quot;extensions/v1beta1&quot;, &quot;PodSecurityPolicy&quot;) %K8s.Operation{ method: :delete, verb: :deletecollection, api_version: &quot;extensions/v1beta1&quot;, name: &quot;PodSecurityPolicy&quot;, path_params: [] } iex&gt; K8s.Client.delete_all(&quot;storage.k8s.io/v1&quot;, &quot;StorageClass&quot;) %K8s.Operation{ method: :delete, verb: :deletecollection, api_version: &quot;storage.k8s.io/v1&quot;, name: &quot;StorageClass&quot;, path_params: [] }"},{"ref":"K8s.Client.html#delete_all/3","title":"K8s.Client.delete_all/3","type":"function","doc":"Returns a DELETE collection operation for all instances of a resource kind in a specific namespace. Examples iex&gt; K8s.Client.delete_all(&quot;apps/v1beta1&quot;, &quot;ControllerRevision&quot;, namespace: &quot;default&quot;) %K8s.Operation{ method: :delete, verb: :deletecollection, api_version: &quot;apps/v1beta1&quot;, name: &quot;ControllerRevision&quot;, path_params: [namespace: &quot;default&quot;] } iex&gt; K8s.Client.delete_all(&quot;apps/v1&quot;, &quot;Deployment&quot;, namespace: &quot;staging&quot;) %K8s.Operation{ method: :delete, verb: :deletecollection, api_version: &quot;apps/v1&quot;, name: &quot;Deployment&quot;, path_params: [namespace: &quot;staging&quot;] }"},{"ref":"K8s.Client.html#get/1","title":"K8s.Client.get/1","type":"function","doc":"Returns a GET operation for a resource given a manifest. May be a partial manifest as long as it contains: apiVersion kind metadata.name metadata.namespace (if applicable) K8s Docs: Get will retrieve a specific resource object by name. Examples Getting a pod iex&gt; pod = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;v1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Pod&quot;, ...&gt; &quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx-pod&quot;, &quot;namespace&quot; =&gt; &quot;test&quot;}, ...&gt; &quot;spec&quot; =&gt; %{&quot;containers&quot; =&gt; %{&quot;image&quot; =&gt; &quot;nginx&quot;}} ...&gt; } ...&gt; K8s.Client.get(pod) %K8s.Operation{ method: :get, verb: :get, api_version: &quot;v1&quot;, name: &quot;Pod&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx-pod&quot;], }"},{"ref":"K8s.Client.html#get/3","title":"K8s.Client.get/3","type":"function","doc":"Returns a GET operation for a resource by version, kind/resource type, name, and optionally namespace. K8s Docs: Get will retrieve a specific resource object by name. Examples Get the nginx deployment in the default namespace: iex&gt; K8s.Client.get(&quot;apps/v1&quot;, &quot;Deployment&quot;, namespace: &quot;test&quot;, name: &quot;nginx&quot;) %K8s.Operation{ method: :get, verb: :get, api_version: &quot;apps/v1&quot;, name: &quot;Deployment&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;] } Get the nginx deployment in the default namespace: iex&gt; K8s.Client.get(&quot;apps/v1&quot;, :deployment, namespace: &quot;test&quot;, name: &quot;nginx&quot;) %K8s.Operation{ method: :get, verb: :get, api_version: &quot;apps/v1&quot;, name: :deployment, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;]} Get the nginx deployment&#39;s status: iex&gt; K8s.Client.get(&quot;apps/v1&quot;, &quot;deployments/status&quot;, namespace: &quot;test&quot;, name: &quot;nginx&quot;) %K8s.Operation{ method: :get, verb: :get, api_version: &quot;apps/v1&quot;, name: &quot;deployments/status&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;]} Get the nginx deployment&#39;s scale: iex&gt; K8s.Client.get(&quot;v1&quot;, &quot;deployments/scale&quot;, namespace: &quot;test&quot;, name: &quot;nginx&quot;) %K8s.Operation{ method: :get, verb: :get, api_version: &quot;v1&quot;, name: &quot;deployments/scale&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;]}"},{"ref":"K8s.Client.html#list/3","title":"K8s.Client.list/3","type":"function","doc":"Returns a GET operation to list all resources by version, kind, and namespace. Given the namespace :all as an atom, will perform a list across all namespaces. K8s Docs: List will retrieve all resource objects of a specific type within a namespace, and the results can be restricted to resources matching a selector query. List All Namespaces: Like List but retrieves resources across all namespaces. Examples iex&gt; K8s.Client.list(&quot;v1&quot;, &quot;Pod&quot;, namespace: &quot;default&quot;) %K8s.Operation{ method: :get, verb: :list, api_version: &quot;v1&quot;, name: &quot;Pod&quot;, path_params: [namespace: &quot;default&quot;] } iex&gt; K8s.Client.list(&quot;apps/v1&quot;, &quot;Deployment&quot;, namespace: :all) %K8s.Operation{ method: :get, verb: :list_all_namespaces, api_version: &quot;apps/v1&quot;, name: &quot;Deployment&quot;, path_params: [] }"},{"ref":"K8s.Client.html#parallel/3","title":"K8s.Client.parallel/3","type":"function","doc":"alias of K8s.Client.Runner.Async.run/3"},{"ref":"K8s.Client.html#patch/1","title":"K8s.Client.patch/1","type":"function","doc":"Returns a PATCH operation to patch the given resource. K8s Docs: Patch will apply a change to a specific field. How the change is merged is defined per field. Lists may either be replaced or merged. Merging lists will not preserve ordering. Patches will never cause optimistic locking failures, and the last write will win. Patches are recommended when the full state is not read before an update, or when failing on optimistic locking is undesirable. When patching complex types, arrays and maps, how the patch is applied is defined on a per-field basis and may either replace the field&#39;s current value, or merge the contents into the current value. Examples iex&gt; deployment = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Deployment&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; }, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;test&quot; ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;replicas&quot; =&gt; 2, ...&gt; &quot;selector&quot; =&gt; %{ ...&gt; &quot;matchLabels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;template&quot; =&gt; %{ ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;containers&quot; =&gt; %{ ...&gt; &quot;image&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; K8s.Client.patch(deployment) %K8s.Operation{ method: :patch, verb: :patch, api_version: &quot;apps/v1&quot;, name: &quot;Deployment&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;], data: %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; }, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;test&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 2, &quot;selector&quot; =&gt; %{ &quot;matchLabels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; %{ &quot;image&quot; =&gt; &quot;nginx&quot;, &quot;name&quot; =&gt; &quot;nginx&quot; } } } } } }"},{"ref":"K8s.Client.html#patch/2","title":"K8s.Client.patch/2","type":"function","doc":"Returns a PATCH operation to patch the given subresource given a resource map and a subresource map."},{"ref":"K8s.Client.html#patch/4","title":"K8s.Client.patch/4","type":"function","doc":"Returns a PATCH operation to patch the given subresource given a resource&#39;s details and a subresource map."},{"ref":"K8s.Client.html#run/2","title":"K8s.Client.run/2","type":"function","doc":"alias of K8s.Client.Runner.Base.run/2"},{"ref":"K8s.Client.html#run/3","title":"K8s.Client.run/3","type":"function","doc":"alias of K8s.Client.Runner.Base.run/3"},{"ref":"K8s.Client.html#run/4","title":"K8s.Client.run/4","type":"function","doc":"alias of K8s.Client.Runner.Base.run/4"},{"ref":"K8s.Client.html#stream/2","title":"K8s.Client.stream/2","type":"function","doc":"alias of K8s.Client.Runner.Stream.run/2"},{"ref":"K8s.Client.html#stream/3","title":"K8s.Client.stream/3","type":"function","doc":"alias of K8s.Client.Runner.Stream.run/3"},{"ref":"K8s.Client.html#update/1","title":"K8s.Client.update/1","type":"function","doc":"Returns a PUT operation to replace/update the given resource. K8s Docs: Replacing a resource object will update the resource by replacing the existing spec with the provided one. For read-then-write operations this is safe because an optimistic lock failure will occur if the resource was modified between the read and write. Note: The ResourceStatus will be ignored by the system and will not be updated. To update the status, one must invoke the specific status update operation. Note: Replacing a resource object may not result immediately in changes being propagated to downstream objects. For instance replacing a ConfigMap or Secret resource will not result in all Pods seeing the changes unless the Pods are restarted out of band. Examples iex&gt; deployment = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Deployment&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; }, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;test&quot; ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;replicas&quot; =&gt; 2, ...&gt; &quot;selector&quot; =&gt; %{ ...&gt; &quot;matchLabels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;template&quot; =&gt; %{ ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;containers&quot; =&gt; %{ ...&gt; &quot;image&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; K8s.Client.update(deployment) %K8s.Operation{ method: :put, verb: :update, api_version: &quot;apps/v1&quot;, name: &quot;Deployment&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;], data: %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; }, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;test&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 2, &quot;selector&quot; =&gt; %{ &quot;matchLabels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; %{ &quot;image&quot; =&gt; &quot;nginx&quot;, &quot;name&quot; =&gt; &quot;nginx&quot; } } } } } }"},{"ref":"K8s.Client.html#update/2","title":"K8s.Client.update/2","type":"function","doc":"Returns a PUT operation to replace/update the given subresource given a resource map and a subresource map. Used for updating subresources like Scale or Status. Examples Scaling a deployment: iex&gt; deployment = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Deployment&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; }, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;test&quot; ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;replicas&quot; =&gt; 2, ...&gt; &quot;selector&quot; =&gt; %{ ...&gt; &quot;matchLabels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;template&quot; =&gt; %{ ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;containers&quot; =&gt; %{ ...&gt; &quot;image&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; scale = %{ ...&gt; &quot;kind&quot; =&gt; &quot;Scale&quot;, ...&gt; &quot;apiVersion&quot; =&gt; &quot;apps/v1beta1&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;test&quot; ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;replicas&quot; =&gt; 3 ...&gt; } ...&gt; } ...&gt; K8s.Client.update(deployment, scale) %K8s.Operation{api_version: &quot;apps/v1&quot;, method: :put, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;], verb: :update, data: %{&quot;apiVersion&quot; =&gt; &quot;apps/v1beta1&quot;, &quot;kind&quot; =&gt; &quot;Scale&quot;, &quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;test&quot;}, &quot;spec&quot; =&gt; %{&quot;replicas&quot; =&gt; 3}}, name: {&quot;Deployment&quot;, &quot;Scale&quot;}}"},{"ref":"K8s.Client.html#update/4","title":"K8s.Client.update/4","type":"function","doc":"Returns a PUT operation to replace/update the given subresource given a resource&#39;s details and a subresource map. Used for updating subresources like Scale or Status. Examples Scaling a deployment iex&gt; scale = %{ ...&gt; &quot;kind&quot; =&gt; &quot;Scale&quot;, ...&gt; &quot;apiVersion&quot; =&gt; &quot;apps/v1beta1&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;default&quot; ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;replicas&quot; =&gt; 3 ...&gt; } ...&gt; } ...&gt; K8s.Client.update(&quot;apps/v1&quot;, &quot;deployments/scale&quot;, [namespace: &quot;default&quot;, name: &quot;nginx&quot;], scale) %K8s.Operation{api_version: &quot;apps/v1&quot;, data: %{&quot;apiVersion&quot; =&gt; &quot;apps/v1beta1&quot;, &quot;kind&quot; =&gt; &quot;Scale&quot;, &quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;default&quot;}, &quot;spec&quot; =&gt; %{&quot;replicas&quot; =&gt; 3}}, method: :put, name: &quot;deployments/scale&quot;, path_params: [namespace: &quot;default&quot;, name: &quot;nginx&quot;], verb: :update}"},{"ref":"K8s.Client.html#wait_until/3","title":"K8s.Client.wait_until/3","type":"function","doc":"alias of K8s.Client.Runner.Wait.run/3"},{"ref":"K8s.Client.html#watch/3","title":"K8s.Client.watch/3","type":"function","doc":"alias of K8s.Client.Runner.Watch.run/3"},{"ref":"K8s.Client.html#watch/4","title":"K8s.Client.watch/4","type":"function","doc":"alias of K8s.Client.Runner.Watch.run/4"},{"ref":"K8s.Client.html#t:option/0","title":"K8s.Client.option/0","type":"type","doc":""},{"ref":"K8s.Client.html#t:options/0","title":"K8s.Client.options/0","type":"type","doc":""},{"ref":"K8s.Client.Behaviour.html","title":"K8s.Client.Behaviour","type":"behaviour","doc":"HTTP Request / Response provider behaviour"},{"ref":"K8s.Client.Behaviour.html#c:handle_response/1","title":"K8s.Client.Behaviour.handle_response/1","type":"callback","doc":"Handle HTTP Responses"},{"ref":"K8s.Client.Behaviour.html#c:headers/2","title":"K8s.Client.Behaviour.headers/2","type":"callback","doc":"Generate headers for HTTP Requests"},{"ref":"K8s.Client.Behaviour.html#c:request/5","title":"K8s.Client.Behaviour.request/5","type":"callback","doc":"Perform HTTP Requests"},{"ref":"K8s.Client.DynamicHTTPProvider.html","title":"K8s.Client.DynamicHTTPProvider","type":"module","doc":"Allows for registration of K8s.Client.Behaviour handlers per-process. Used internally by the test suite for testing/mocking kubernetes responses."},{"ref":"K8s.Client.DynamicHTTPProvider.html#child_spec/1","title":"K8s.Client.DynamicHTTPProvider.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"K8s.Client.DynamicHTTPProvider.html#list/0","title":"K8s.Client.DynamicHTTPProvider.list/0","type":"function","doc":"List all registered handlers"},{"ref":"K8s.Client.DynamicHTTPProvider.html#lookup/1","title":"K8s.Client.DynamicHTTPProvider.lookup/1","type":"function","doc":"Lookup the handler module for this process"},{"ref":"K8s.Client.DynamicHTTPProvider.html#register/2","title":"K8s.Client.DynamicHTTPProvider.register/2","type":"function","doc":"Register the handler mdoule for this process"},{"ref":"K8s.Client.DynamicHTTPProvider.html#request/5","title":"K8s.Client.DynamicHTTPProvider.request/5","type":"function","doc":"Dispatch request/5 to the module registered in the current process. If the current process is not register, check its parent. This is useful when requests are made from child processes e.g.: (Task.async/1)"},{"ref":"K8s.Client.DynamicHTTPProvider.html#start_link/1","title":"K8s.Client.DynamicHTTPProvider.start_link/1","type":"function","doc":"Starts this provider."},{"ref":"K8s.Client.HTTPProvider.html","title":"K8s.Client.HTTPProvider","type":"module","doc":"HTTPoison and Jason based K8s.Client.Behaviour"},{"ref":"K8s.Client.HTTPProvider.html#handle_response/1","title":"K8s.Client.HTTPProvider.handle_response/1","type":"function","doc":"Handle HTTPoison responses and errors Examples Parses successful JSON responses: iex&gt; body = ~s({&quot;foo&quot;: &quot;bar&quot;}) ...&gt; K8s.Client.HTTPProvider.handle_response({:ok, %HTTPoison.Response{status_code: 200, body: body}}) {:ok, %{&quot;foo&quot; =&gt; &quot;bar&quot;}} Parses successful JSON responses: iex&gt; body = &quot;line 1\\nline 2\\nline 3\\n&quot; ...&gt; K8s.Client.HTTPProvider.handle_response({:ok, %HTTPoison.Response{status_code: 200, body: body, headers: [{&quot;Content-Type&quot;, &quot;text/plain&quot;}]}}) {:ok, &quot;line 1\\nline 2\\nline 3\\n&quot;} Handles unauthorized responses: iex&gt; K8s.Client.HTTPProvider.handle_response({:ok, %HTTPoison.Response{status_code: 401}}) {:error, :unauthorized} Handles not found responses: iex&gt; K8s.Client.HTTPProvider.handle_response({:ok, %HTTPoison.Response{status_code: 404}}) {:error, :not_found} Passes through HTTPoison 4xx responses: iex&gt; K8s.Client.HTTPProvider.handle_response({:ok, %HTTPoison.Response{status_code: 410, body: &quot;Gone&quot;}}) {:error, %HTTPoison.Response{status_code: 410, body: &quot;Gone&quot;}} Passes through HTTPoison error responses: iex&gt; K8s.Client.HTTPProvider.handle_response({:error, %HTTPoison.Error{reason: &quot;Foo&quot;}}) {:error, %HTTPoison.Error{reason: &quot;Foo&quot;}}"},{"ref":"K8s.Client.HTTPProvider.html#headers/2","title":"K8s.Client.HTTPProvider.headers/2","type":"function","doc":"Generates HTTP headers from K8s.Conf.RequestOptions Adds {&quot;Accept&quot;, &quot;application/json&quot;} to all requests. Adds Content-Type base on HTTP method. Example Sets Content-Type to application/merge-patch+json for PATCH operations iex&gt; opts = %K8s.Conf.RequestOptions{headers: [{&quot;Authorization&quot;, &quot;Basic AF&quot;}]} ...&gt; K8s.Client.HTTPProvider.headers(:patch, opts) [{&quot;Accept&quot;, &quot;application/json&quot;}, {&quot;Content-Type&quot;, &quot;application/merge-patch+json&quot;}, {&quot;Authorization&quot;, &quot;Basic AF&quot;}] Sets Content-Type to application/json for all other operations iex&gt; opts = %K8s.Conf.RequestOptions{headers: [{&quot;Authorization&quot;, &quot;Basic AF&quot;}]} ...&gt; K8s.Client.HTTPProvider.headers(:get, opts) [{&quot;Accept&quot;, &quot;application/json&quot;}, {&quot;Content-Type&quot;, &quot;application/json&quot;}, {&quot;Authorization&quot;, &quot;Basic AF&quot;}]"},{"ref":"K8s.Client.Runner.Async.html","title":"K8s.Client.Runner.Async","type":"module","doc":"K8s.Client runner to process a batch of operations in parallel."},{"ref":"K8s.Client.Runner.Async.html#run/3","title":"K8s.Client.Runner.Async.run/3","type":"function","doc":"Runs multiple operations in parallel. Operations will be returned in same order given. Operations will not cease in event of failure. Example Get a list of pods, then map each one to an individual GET operation: # Get the pods operation = K8s.Client.list(&quot;v1&quot;, &quot;Pod&quot;, namespace: :all) {:ok, %{&quot;items&quot; =&gt; pods}} = K8s.Client.run(operation, :test_cluster) # Map each one to an individual `GET` operation. operations = Enum.map(pods, fn(%{&quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; name, &quot;namespace&quot; =&gt; ns}}) -&gt; K8s.Client.get(&quot;v1&quot;, &quot;Pod&quot;, namespace: ns, name: name) end) # Get the results asynchronously results = K8s.Client.Async.run(operations, :test_cluster)"},{"ref":"K8s.Client.Runner.Base.html","title":"K8s.Client.Runner.Base","type":"module","doc":"Base HTTP processor for K8s.Client"},{"ref":"K8s.Client.Runner.Base.html#encode/2","title":"K8s.Client.Runner.Base.encode/2","type":"function","doc":""},{"ref":"K8s.Client.Runner.Base.html#run/2","title":"K8s.Client.Runner.Base.run/2","type":"function","doc":"Runs a K8s.Operation. Examples Note: Examples assume a cluster was registered named :test_cluster, see K8s.Cluster.Registry.add/2. Running a list pods operation: operation = K8s.Client.list(&quot;v1&quot;, &quot;Pod&quot;, namespace: :all) {:ok, %{&quot;items&quot; =&gt; pods}} = K8s.Client.run(operation, :test_cluster) Running a dry-run of a create deployment operation: deployment = %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; }, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;test&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 2, &quot;selector&quot; =&gt; %{ &quot;matchLabels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; %{ &quot;image&quot; =&gt; &quot;nginx&quot;, &quot;name&quot; =&gt; &quot;nginx&quot; } } } } } operation = K8s.Client.create(deployment) # opts is passed to HTTPoison as opts. opts = [params: %{&quot;dryRun&quot; =&gt; &quot;all&quot;}] :ok = K8s.Client.Runner.Base.run(operation, :test_cluster, opts)"},{"ref":"K8s.Client.Runner.Base.html#run/3","title":"K8s.Client.Runner.Base.run/3","type":"function","doc":"Run an operation and pass opts to HTTPoison. See run/2"},{"ref":"K8s.Client.Runner.Base.html#run/4","title":"K8s.Client.Runner.Base.run/4","type":"function","doc":"Run an operation with an alternative HTTP Body (map) and pass opts to HTTPoison. See run/2"},{"ref":"K8s.Client.Runner.Base.html#t:result_t/0","title":"K8s.Client.Runner.Base.result_t/0","type":"type","doc":""},{"ref":"K8s.Client.Runner.Stream.html","title":"K8s.Client.Runner.Stream","type":"module","doc":"Takes a K8s.Client.list/3 operation and returns an Elixir Stream"},{"ref":"K8s.Client.Runner.Stream.html#run/3","title":"K8s.Client.Runner.Stream.run/3","type":"function","doc":"Validates operation type before calling stream/3. Only supports verbs: list_all_namespaces and list."},{"ref":"K8s.Client.Runner.Stream.html#stream/3","title":"K8s.Client.Runner.Stream.stream/3","type":"function","doc":"Returns an elixir stream of paginated list results. Elements in stream will be HTTP bodies, or error tuples. Encountering an HTTP error mid-stream will halt the stream."},{"ref":"K8s.Client.Runner.Stream.html#t:halt_t/0","title":"K8s.Client.Runner.Stream.halt_t/0","type":"type","doc":"Halt streaming"},{"ref":"K8s.Client.Runner.Stream.html#t:state_t/0","title":"K8s.Client.Runner.Stream.state_t/0","type":"type","doc":"List of items and pagination request"},{"ref":"K8s.Client.Runner.Stream.ListRequest.html","title":"K8s.Client.Runner.Stream.ListRequest","type":"module","doc":":list K8s.Operation encapsulated with pagination and cluster details"},{"ref":"K8s.Client.Runner.Stream.ListRequest.html#make_next_request/2","title":"K8s.Client.Runner.Stream.ListRequest.make_next_request/2","type":"function","doc":"Creates a ListRequest struct for the next HTTP request from the previous HTTP response"},{"ref":"K8s.Client.Runner.Stream.ListRequest.html#t:continue_t/0","title":"K8s.Client.Runner.Stream.ListRequest.continue_t/0","type":"type","doc":"Pagination continue token"},{"ref":"K8s.Client.Runner.Stream.ListRequest.html#t:opts_t/0","title":"K8s.Client.Runner.Stream.ListRequest.opts_t/0","type":"type","doc":"opts for Base.run/3"},{"ref":"K8s.Client.Runner.Stream.ListRequest.html#t:t/0","title":"K8s.Client.Runner.Stream.ListRequest.t/0","type":"type","doc":"List operation as a Stream data type"},{"ref":"K8s.Client.Runner.Wait.html","title":"K8s.Client.Runner.Wait","type":"module","doc":"Waiting functionality for K8s.Client. Note: This is built using repeated GET operations rather than using a watch operation w/ fieldSelector."},{"ref":"K8s.Client.Runner.Wait.html#run/3","title":"K8s.Client.Runner.Wait.run/3","type":"function","doc":"Continually perform a GET based operation until a condition is met. Example Checking the number of job completions: op = K8s.Client.get(&quot;batch/v1&quot;, :job, namespace: &quot;default&quot;, name: &quot;sleep&quot;) opts = [find: [&quot;status&quot;, &quot;succeeded&quot;], eval: 1, timeout: 60] resp = K8s.Client.Runner.Wait.run(op, cluster_name, opts)"},{"ref":"K8s.Client.Runner.Wait.html#t:t/0","title":"K8s.Client.Runner.Wait.t/0","type":"type","doc":"A wait configuration"},{"ref":"K8s.Client.Runner.Watch.html","title":"K8s.Client.Runner.Watch","type":"module","doc":"K8s.Client runner that will watch a resource or resources and stream results back to a process."},{"ref":"K8s.Client.Runner.Watch.html#run/3","title":"K8s.Client.Runner.Watch.run/3","type":"function","doc":"Watch a resource or list of resources. Provide the stream_to option or results will be stream to self(). Note: Current resource version will be looked up automatically. Examples operation = K8s.Client.list(&quot;v1&quot;, &quot;Namespace&quot;) {:ok, reference} = Watch.run(operation, :test, stream_to: self()) operation = K8s.Client.get(&quot;v1&quot;, &quot;Namespace&quot;, [name: &quot;test&quot;]) {:ok, reference} = Watch.run(operation, :test, stream_to: self())"},{"ref":"K8s.Client.Runner.Watch.html#run/4","title":"K8s.Client.Runner.Watch.run/4","type":"function","doc":"Watch a resource or list of resources from a specific resource version. Provide the stream_to option or results will be stream to self(). Examples operation = K8s.Client.list(&quot;v1&quot;, &quot;Namespace&quot;) resource_version = 3003 {:ok, reference} = Watch.run(operation, :test, resource_version, stream_to: self()) operation = K8s.Client.get(&quot;v1&quot;, &quot;Namespace&quot;, [name: &quot;test&quot;]) resource_version = 3003 {:ok, reference} = Watch.run(operation, :test, resource_version, stream_to: self())"},{"ref":"K8s.Cluster.html","title":"K8s.Cluster","type":"module","doc":"Cluster configuration and API route store for K8s.Client"},{"ref":"K8s.Cluster.html#base_url/1","title":"K8s.Cluster.base_url/1","type":"function","doc":"Retrieve the base URL for a cluster Examples iex&gt; conf = K8s.Conf.from_file(&quot;./test/support/kube-config.yaml&quot;) ...&gt; K8s.Cluster.Registry.add(:test_cluster, conf) ...&gt; K8s.Cluster.base_url(:test_cluster) {:ok, &quot;https://localhost:6443&quot;}"},{"ref":"K8s.Cluster.html#conf/1","title":"K8s.Cluster.conf/1","type":"function","doc":"Retrieve a cluster&#39;s connection configuration. Example iex&gt; config_file = K8s.Conf.from_file(&quot;./test/support/kube-config.yaml&quot;, [user: &quot;token-user&quot;]) ...&gt; K8s.Cluster.Registry.add(:test_cluster, config_file) ...&gt; {:ok, conf} = K8s.Cluster.conf(:test_cluster) ...&gt; conf %K8s.Conf{auth: %K8s.Conf.Auth.Token{token: &quot;just-a-token-user-pun-intended&quot;}, ca_cert: nil, cluster_name: &quot;docker-for-desktop-cluster&quot;, insecure_skip_tls_verify: true, url: &quot;https://localhost:6443&quot;,user_name: &quot;token-user&quot;}"},{"ref":"K8s.Cluster.html#list/0","title":"K8s.Cluster.list/0","type":"function","doc":"List registered cluster names"},{"ref":"K8s.Cluster.html#url_for/2","title":"K8s.Cluster.url_for/2","type":"function","doc":"Retrieve the URL for a K8s.Operation Examples iex&gt; conf = K8s.Conf.from_file(&quot;./test/support/kube-config.yaml&quot;) ...&gt; K8s.Cluster.Registry.add(:test_cluster, conf) ...&gt; operation = K8s.Operation.build(:get, &quot;apps/v1&quot;, :deployments, [namespace: &quot;default&quot;, name: &quot;nginx&quot;]) ...&gt; K8s.Cluster.url_for(operation, :test_cluster) {:ok, &quot;https://localhost:6443/apis/apps/v1/namespaces/default/deployments/nginx&quot;}"},{"ref":"K8s.Cluster.Discovery.html","title":"K8s.Cluster.Discovery","type":"module","doc":"Interface for K8s.Cluster discovery. This module implements K8s.Cluster.Discovery.Driver behaviour and delegates function calls to the configured @driver. This defaults to the K8s.Cluster.Discovery.HTTPDriver The driver can be set with: Application.get_env(:k8s, :discovery_driver, MyCustomDiscoveryDriver)"},{"ref":"K8s.Cluster.Discovery.html#api_versions/2","title":"K8s.Cluster.Discovery.api_versions/2","type":"function","doc":"Lists Kubernetes apiVersions Delegates to the configured driver."},{"ref":"K8s.Cluster.Discovery.html#resource_definitions/2","title":"K8s.Cluster.Discovery.resource_definitions/2","type":"function","doc":"Lists Kubernetes APIResourceLists Delegates to the configured driver."},{"ref":"K8s.Cluster.Discovery.html#resources_by_group/2","title":"K8s.Cluster.Discovery.resources_by_group/2","type":"function","doc":"Get all resources keyed by groupVersion/apiVersion membership."},{"ref":"K8s.Cluster.Discovery.Driver.html","title":"K8s.Cluster.Discovery.Driver","type":"behaviour","doc":"Behaviour for K8s.Cluster.Discovery"},{"ref":"K8s.Cluster.Discovery.Driver.html#c:api_versions/2","title":"K8s.Cluster.Discovery.Driver.api_versions/2","type":"callback","doc":"List of Kubernetes apiVersions"},{"ref":"K8s.Cluster.Discovery.Driver.html#c:resource_definitions/2","title":"K8s.Cluster.Discovery.Driver.resource_definitions/2","type":"callback","doc":"List of Kubernetes APIResourceLists"},{"ref":"K8s.Cluster.Discovery.FileDriver.html","title":"K8s.Cluster.Discovery.FileDriver","type":"module","doc":"K8s.Cluster.Discovery.Driver implementation that returns kubernetes API features from file"},{"ref":"K8s.Cluster.Discovery.HTTPDriver.html","title":"K8s.Cluster.Discovery.HTTPDriver","type":"module","doc":"K8s.Cluster.Discovery.Driver implementation that makes calls to Kubernetes REST API. No caching is implemented in this driver and all calls will result in /api and /apis discovery"},{"ref":"K8s.Cluster.Group.html","title":"K8s.Cluster.Group","type":"module","doc":"Kubernetes API Groups"},{"ref":"K8s.Cluster.Group.html#find_resource/3","title":"K8s.Cluster.Group.find_resource/3","type":"function","doc":"Finds a resource definition by api version and (name or kind)."},{"ref":"K8s.Cluster.Group.html#insert_all/2","title":"K8s.Cluster.Group.insert_all/2","type":"function","doc":"Insert/Update a cluster&#39;s group/resource definitions."},{"ref":"K8s.Cluster.Group.html#resource_name_for_kind/3","title":"K8s.Cluster.Group.resource_name_for_kind/3","type":"function","doc":"Get the REST resource name for a kubernetes Kind. Since K8s.Operation is abstracted away from a specific cluster, when working with kubernetes resource Maps and specifying &quot;kind&quot; the K8s.Operation.Path module isn&#39;t able to determine the correct path. (It will generate things like /api/v1/Pod instead of api/v1/pods). Also accepts REST resource name in the event they are provided, as it may be known in the event of subresources."},{"ref":"K8s.Cluster.Group.html#resources_by_group/2","title":"K8s.Cluster.Group.resources_by_group/2","type":"function","doc":"Returns a list of all resources in a given groupVersion"},{"ref":"K8s.Cluster.RegistrationException.html","title":"K8s.Cluster.RegistrationException","type":"exception","doc":""},{"ref":"K8s.Cluster.Registry.html","title":"K8s.Cluster.Registry","type":"module","doc":"Register resource definitions for K8s.Cluster"},{"ref":"K8s.Cluster.Registry.html#add/2","title":"K8s.Cluster.Registry.add/2","type":"function","doc":"Add or update a cluster to use with K8s.Client Examples iex&gt; conf = K8s.Conf.from_file(&quot;./test/support/kube-config.yaml&quot;) ...&gt; K8s.Cluster.Registry.add(:test_cluster, conf) {:ok, :test_cluster}"},{"ref":"K8s.Cluster.Registry.html#add!/2","title":"K8s.Cluster.Registry.add!/2","type":"function","doc":"Add or update a new cluster to use with K8s.Client Examples iex&gt; conf = K8s.Conf.from_file(&quot;./test/support/kube-config.yaml&quot;) ...&gt; K8s.Cluster.Registry.add!(:test_cluster, conf) :test_cluster"},{"ref":"K8s.Cluster.Registry.html#auto_register_clusters!/0","title":"K8s.Cluster.Registry.auto_register_clusters!/0","type":"function","doc":"Registers clusters automatically from all configuration sources. See the usage guide for more details on configuring connection details. Examples By default a cluster will attempt to use the ServiceAccount assigned to the pod: config :k8s, clusters: %{ default: %{} } Configuring a cluster using a k8s config: config :k8s, clusters: %{ default: %{ conf: &quot;~/.kube/config&quot; conf_opts: [user: &quot;some-user&quot;, cluster: &quot;prod-cluster&quot;] } }"},{"ref":"K8s.Cluster.Registry.html#child_spec/1","title":"K8s.Cluster.Registry.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"K8s.Cluster.Registry.html#schedule/1","title":"K8s.Cluster.Registry.schedule/1","type":"function","doc":"Schedules a re-registration of all clusters."},{"ref":"K8s.Cluster.Registry.html#start_link/1","title":"K8s.Cluster.Registry.start_link/1","type":"function","doc":""},{"ref":"K8s.Conf.html","title":"K8s.Conf","type":"module","doc":"Handles authentication and connection configuration details for a Kubernetes cluster."},{"ref":"K8s.Conf.html#from_file/2","title":"K8s.Conf.from_file/2","type":"function","doc":"Reads configuration details from a kubernetes config file. Defaults to current-context. Options context sets an alternate context cluster set or override the cluster read from the context user set or override the user read from the context"},{"ref":"K8s.Conf.html#from_service_account/0","title":"K8s.Conf.from_service_account/0","type":"function","doc":"Generates configuration from kubernetes service account Links kubernetes.io :: Accessing the API from a Pod"},{"ref":"K8s.Conf.html#from_service_account/1","title":"K8s.Conf.from_service_account/1","type":"function","doc":""},{"ref":"K8s.Conf.html#t:t/0","title":"K8s.Conf.t/0","type":"type","doc":""},{"ref":"K8s.Conf.Auth.html","title":"K8s.Conf.Auth","type":"behaviour","doc":"Authorization behaviour"},{"ref":"K8s.Conf.Auth.html#c:create/2","title":"K8s.Conf.Auth.create/2","type":"callback","doc":""},{"ref":"K8s.Conf.Auth.AuthProvider.html","title":"K8s.Conf.Auth.AuthProvider","type":"module","doc":"auth-provider authentication support"},{"ref":"K8s.Conf.Auth.AuthProvider.html#generate_token/1","title":"K8s.Conf.Auth.AuthProvider.generate_token/1","type":"function","doc":"&quot;Generate&quot; a token using the auth-provider config in kube config."},{"ref":"K8s.Conf.Auth.AuthProvider.html#t:t/0","title":"K8s.Conf.Auth.AuthProvider.t/0","type":"type","doc":""},{"ref":"K8s.Conf.Auth.Certificate.html","title":"K8s.Conf.Auth.Certificate","type":"module","doc":"Certificate based cluster authentication."},{"ref":"K8s.Conf.Auth.Certificate.html#t:t/0","title":"K8s.Conf.Auth.Certificate.t/0","type":"type","doc":""},{"ref":"K8s.Conf.Auth.Token.html","title":"K8s.Conf.Auth.Token","type":"module","doc":"Token based cluster authentication"},{"ref":"K8s.Conf.Auth.Token.html#t:t/0","title":"K8s.Conf.Auth.Token.t/0","type":"type","doc":""},{"ref":"K8s.Conf.PKI.html","title":"K8s.Conf.PKI","type":"module","doc":"Retrieves information from certificates"},{"ref":"K8s.Conf.PKI.html#cert_from_base64/1","title":"K8s.Conf.PKI.cert_from_base64/1","type":"function","doc":"Decodes the certificate from a base64 encoded string"},{"ref":"K8s.Conf.PKI.html#cert_from_map/2","title":"K8s.Conf.PKI.cert_from_map/2","type":"function","doc":"Reads the certificate from PEM file or base64 encoding"},{"ref":"K8s.Conf.PKI.html#cert_from_pem/1","title":"K8s.Conf.PKI.cert_from_pem/1","type":"function","doc":"Reads the certificate from a PEM file"},{"ref":"K8s.Conf.PKI.html#private_key_from_base64/1","title":"K8s.Conf.PKI.private_key_from_base64/1","type":"function","doc":"Decodes private key from a base64 encoded string"},{"ref":"K8s.Conf.PKI.html#private_key_from_pem/1","title":"K8s.Conf.PKI.private_key_from_pem/1","type":"function","doc":"Reads private key from a PEM file"},{"ref":"K8s.Conf.RequestOptions.html","title":"K8s.Conf.RequestOptions","type":"protocol","doc":"Encapsulates HTTP request options for an authentication provider."},{"ref":"K8s.Conf.RequestOptions.html#generate/1","title":"K8s.Conf.RequestOptions.generate/1","type":"function","doc":""},{"ref":"K8s.Conf.RequestOptions.html#t:generate_t/0","title":"K8s.Conf.RequestOptions.generate_t/0","type":"type","doc":"generate/1 response type"},{"ref":"K8s.Conf.RequestOptions.html#t:t/0","title":"K8s.Conf.RequestOptions.t/0","type":"type","doc":"HTTP Request options"},{"ref":"K8s.Config.html","title":"K8s.Config","type":"module","doc":"Add runtime cluster configuration with environment variables. Each variable consists of a prefix that determines where the value will be placed in the config and a suffix that is the cluster name. The cluster name will be atomized. Environment Variable Prefixes: K8S_CLUSTER_CONF_SA_ - boolean enables authentication to the k8s API with the pods spec.serviceAccountName. K8S_CLUSTER_CONF_PATH_ - string absolute path to the kube config file. K8S_CLUSTER_CONF_CONTEXT_ string which context to use in the kube config file. Examples export K8S_CLUSTER_CONF_SA_us_central=true export K8S_CLUSTER_CONF_PATH_us_east=&quot;east.yaml&quot; export K8S_CLUSTER_CONF_CONTEXT_us_east=&quot;east&quot; export K8S_CLUSTER_CONF_PATH_us_west=&quot;west.yaml&quot; export K8S_CLUSTER_CONF_CONTEXT_us_west=&quot;west&quot;"},{"ref":"K8s.Config.html#clusters/0","title":"K8s.Config.clusters/0","type":"function","doc":"Returns runtime and compile time cluster configuration merged together."},{"ref":"K8s.Config.html#discovery_http_timeout/1","title":"K8s.Config.discovery_http_timeout/1","type":"function","doc":"Discovery HTTP call timeouts in ms for each API endpoint. API endpoints are discovered in parallel. This controls the timeout for any given HTTP request. Examples export K8S_DISCOVERY_TIMEOUT_us_central=10000"},{"ref":"K8s.Config.html#env/0","title":"K8s.Config.env/0","type":"function","doc":"Subset of env vars applicable to k8s"},{"ref":"K8s.Config.html#runtime_clusters_config/2","title":"K8s.Config.runtime_clusters_config/2","type":"function","doc":"Cluster configuration read from env variables. To be merged over Application.get_env(:k8s, :clusters). Examples Overriding compile time configs iex&gt; env = %{&quot;K8S_CLUSTER_CONF_PATH_dev&quot; =&gt; &quot;runtime/path/to/dev.conf&quot;} ...&gt; compile_config = %{dev: %{conf: &quot;compiletime/path/to/dev.conf&quot;}} ...&gt; K8s.Config.runtime_clusters_config(env, compile_config) %{dev: %{conf: &quot;runtime/path/to/dev.conf&quot;}} Merging compile time configs iex&gt; env = %{&quot;K8S_CLUSTER_CONF_CONTEXT_dev&quot; =&gt; &quot;runtime-context&quot;} ...&gt; compile_config = %{dev: %{conf: &quot;compiletime/path/to/dev.conf&quot;}} ...&gt; K8s.Config.runtime_clusters_config(env, compile_config) %{dev: %{conf: &quot;compiletime/path/to/dev.conf&quot;, conf_opts: [context: &quot;runtime-context&quot;]}} Adding clusters at runtime iex&gt; env = %{&quot;K8S_CLUSTER_CONF_PATH_us_east&quot; =&gt; &quot;runtime/path/to/us_east.conf&quot;, &quot;K8S_CLUSTER_CONF_CONTEXT_us_east&quot; =&gt; &quot;east-context&quot;} ...&gt; compile_config = %{us_west: %{conf: &quot;compiletime/path/to/us_west.conf&quot;}} ...&gt; K8s.Config.runtime_clusters_config(env, compile_config) %{us_east: %{conf: &quot;runtime/path/to/us_east.conf&quot;, conf_opts: [context: &quot;east-context&quot;]}, us_west: %{conf: &quot;compiletime/path/to/us_west.conf&quot;}}"},{"ref":"K8s.Operation.html","title":"K8s.Operation","type":"module","doc":"Encapsulates Kubernetes REST API operations."},{"ref":"K8s.Operation.html#build/2","title":"K8s.Operation.build/2","type":"function","doc":"Builds an Operation given a verb and a k8s resource. Examples iex&gt; deploy = %{&quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{&quot;namespace&quot; =&gt; &quot;default&quot;, &quot;name&quot; =&gt; &quot;nginx&quot;}} ...&gt; K8s.Operation.build(:update, deploy) %K8s.Operation{ method: :put, verb: :update, data: %{&quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{&quot;namespace&quot; =&gt; &quot;default&quot;, &quot;name&quot; =&gt; &quot;nginx&quot;}}, path_params: [namespace: &quot;default&quot;, name: &quot;nginx&quot;], api_version: &quot;apps/v1&quot;, name: &quot;Deployment&quot; }"},{"ref":"K8s.Operation.html#build/5","title":"K8s.Operation.build/5","type":"function","doc":"Builds an Operation given an verb and a k8s resource info. Note: The name here may be a Kind and not a REST resource name in the event that the operation was built using a map. Use K8s.Cluster.Group.resource_name_for_kind/3 to get the correct REST resource name, given a kind. Examples Building a GET deployment operation: iex&gt; K8s.Operation.build(:get, &quot;apps/v1&quot;, :deployment, [namespace: &quot;default&quot;, name: &quot;nginx&quot;]) %K8s.Operation{ method: :get, verb: :get, data: nil, path_params: [namespace: &quot;default&quot;, name: &quot;nginx&quot;], api_version: &quot;apps/v1&quot;, name: :deployment } Building a GET deployments/status operation: iex&gt; K8s.Operation.build(:get, &quot;apps/v1&quot;, &quot;deployments/status&quot;, [namespace: &quot;default&quot;, name: &quot;nginx&quot;]) %K8s.Operation{ method: :get, verb: :get, data: nil, path_params: [namespace: &quot;default&quot;, name: &quot;nginx&quot;], api_version: &quot;apps/v1&quot;, name: &quot;deployments/status&quot; }"},{"ref":"K8s.Operation.html#to_path/1","title":"K8s.Operation.to_path/1","type":"function","doc":"Converts a K8s.Operation into a URL path."},{"ref":"K8s.Operation.html#t:name_t/0","title":"K8s.Operation.name_t/0","type":"type","doc":"K8s.Operation name. May be an atom, string, or tuple of {resource, subresource}."},{"ref":"K8s.Operation.html#t:t/0","title":"K8s.Operation.t/0","type":"type","doc":"api_version - API groupVersion, AKA apiVersion name - The name of the REST operation (Kubernets kind/resource/subresource). This is not always the same as the kind key in the data field. e.g: deployments when POSTing, GETting a deployment. data - HTTP request body to submit when applicable. (POST, PUT, PATCH, etc) method - HTTP Method verb - Kubernetes REST API verb (deletecollection, update, create, watch, etc) path_params - Parameters to interpolate into the Kubernetes REST URL name would be deployments in the case of a deployment, but may be deployments/status or deployments/scale for Status and Scale subresources. name and data field examples The following example would update the nginx deployment&#39;s Scale. Note the deployments/scale operation will have a Scale data payload: %K8s.Operation{ method: :put, verb: :update, api_version: &quot;v1&quot;, # api version of the &quot;Scale&quot; kind name: &quot;deployments/scale&quot;, data: %{&quot;apiVersion&quot; =&gt; &quot;v1&quot;, &quot;kind&quot; =&gt; &quot;Scale&quot;}, # `data` is of kind &quot;Scale&quot; path_params: [name: &quot;nginx&quot;, namespace: &quot;default&quot;] } The following example would update the nginx deployment&#39;s Status. Note the deployments/status operation will have a Deployment data payload: %K8s.Operation{ method: :put, verb: :update, api_version: &quot;apps/v1&quot;, # api version of the &quot;Deployment&quot; kind name: &quot;deployments/status&quot;, data: %{&quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;}, # `data` is of kind &quot;Deployment&quot; path_params: [name: &quot;nginx&quot;, namespace: &quot;default&quot;] }"},{"ref":"K8s.Operation.Path.html","title":"K8s.Operation.Path","type":"module","doc":"Generates Kubernetes REST API Paths"},{"ref":"K8s.Operation.Path.html#build/1","title":"K8s.Operation.Path.build/1","type":"function","doc":"Generates the API path for a K8s.Operation. Examples Generate a path for a cluster scoped resource: iex&gt; resource = K8s.Resource.build(&quot;apps/v1&quot;, &quot;CertificateSigningRequest&quot;, &quot;foo&quot;) ...&gt; operation = %K8s.Operation{ ...&gt; method: :put, ...&gt; verb: :update, ...&gt; data: resource, ...&gt; path_params: [name: &quot;foo&quot;], ...&gt; api_version: &quot;apps/v1&quot;, ...&gt; name: &quot;certificatesigningrequests&quot; ...&gt; } ...&gt; K8s.Operation.Path.build(operation) {:ok, &quot;/apis/apps/v1/certificatesigningrequests/foo&quot;} Generate a path for a namespace scoped resource: iex&gt; resource = K8s.Resource.build(&quot;v1&quot;, &quot;Pod&quot;, &quot;default&quot;, &quot;foo&quot;) ...&gt; operation = %K8s.Operation{ ...&gt; method: :put, ...&gt; verb: :update, ...&gt; data: resource, ...&gt; path_params: [namespace: &quot;default&quot;, name: &quot;foo&quot;], ...&gt; api_version: &quot;v1&quot;, ...&gt; name: &quot;pods&quot; ...&gt; } ...&gt; K8s.Operation.Path.build(operation) {:ok, &quot;/api/v1/namespaces/default/pods/foo&quot;} Generate a path for a namespace scoped resource on the collection: (ie create, list) iex&gt; resource = K8s.Resource.build(&quot;v1&quot;, &quot;Pod&quot;, &quot;default&quot;, &quot;foo&quot;) ...&gt; operation = %K8s.Operation{ ...&gt; method: :post, ...&gt; verb: :create, ...&gt; data: resource, ...&gt; path_params: [namespace: &quot;default&quot;, name: &quot;foo&quot;], ...&gt; api_version: &quot;v1&quot;, ...&gt; name: &quot;pods&quot; ...&gt; } ...&gt; K8s.Operation.Path.build(operation) {:ok, &quot;/api/v1/namespaces/default/pods&quot;} Generating a listing path for a namespace: iex&gt; operation = %K8s.Operation{ ...&gt; method: :get, ...&gt; verb: :list, ...&gt; data: nil, ...&gt; path_params: [namespace: &quot;default&quot;], ...&gt; api_version: &quot;v1&quot;, ...&gt; name: &quot;pods&quot; ...&gt; } ...&gt; K8s.Operation.Path.build(operation) {:ok, &quot;/api/v1/namespaces/default/pods&quot;} Generating a listing path for a all namespaces: iex&gt; operation = %K8s.Operation{ ...&gt; method: :get, ...&gt; verb: :list_all_namespaces, ...&gt; data: nil, ...&gt; path_params: [namespace: &quot;default&quot;], ...&gt; api_version: &quot;v1&quot;, ...&gt; name: &quot;pods&quot; ...&gt; } ...&gt; K8s.Operation.Path.build(operation) {:ok, &quot;/api/v1/pods&quot;} Generating a path for a subresource: iex&gt; operation = %K8s.Operation{ ...&gt; method: :get, ...&gt; verb: :get, ...&gt; data: nil, ...&gt; path_params: [namespace: &quot;default&quot;, name: &quot;foo&quot;], ...&gt; api_version: &quot;v1&quot;, ...&gt; name: &quot;pods/status&quot; ...&gt; } ...&gt; K8s.Operation.Path.build(operation) {:ok, &quot;/api/v1/namespaces/default/pods/foo/status&quot;} Deleting a collection: iex&gt; operation = %K8s.Operation{ ...&gt; method: :delete, ...&gt; verb: :deletecollection, ...&gt; data: nil, ...&gt; path_params: [namespace: &quot;default&quot;], ...&gt; api_version: &quot;v1&quot;, ...&gt; name: &quot;pods&quot; ...&gt; } ...&gt; K8s.Operation.Path.build(operation) {:ok, &quot;/api/v1/namespaces/default/pods&quot;}"},{"ref":"K8s.Operation.Path.html#find_params/1","title":"K8s.Operation.Path.find_params/1","type":"function","doc":"Find valid path params in a URL path. Examples iex&gt; K8s.Operation.Path.find_params(&quot;/foo/{name}&quot;) [:name] iex&gt; K8s.Operation.Path.find_params(&quot;/foo/{namespace}/bar/{name}&quot;) [:namespace, :name] iex&gt; K8s.Operation.Path.find_params(&quot;/foo/bar&quot;) []"},{"ref":"K8s.Operation.Path.html#replace_path_vars/2","title":"K8s.Operation.Path.replace_path_vars/2","type":"function","doc":"Replaces path variables with options. Examples iex&gt; K8s.Operation.Path.replace_path_vars(&quot;/foo/{name}&quot;, name: &quot;bar&quot;) &quot;/foo/bar&quot;"},{"ref":"K8s.Resource.html","title":"K8s.Resource","type":"module","doc":"Manifest attribute helpers"},{"ref":"K8s.Resource.html#all_from_file!/2","title":"K8s.Resource.all_from_file!/2","type":"function","doc":"Create a list of resource Maps from a YAML file with multi object annotation. Raises File.Error when the file does not exist. Examples iex&gt; opts = [namespace: &quot;default&quot;, name: &quot;nginx&quot;, image: &quot;nginx:nginx:1.7.9&quot;] ...&gt; K8s.Resource.all_from_file!(&quot;test/support/helm-chart.yaml&quot;, opts) [ %{ &quot;apiVersion&quot; =&gt; &quot;v1&quot;, &quot;kind&quot; =&gt; &quot;Namespace&quot;, &quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;default&quot;} }, %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}, &quot;name&quot; =&gt; &quot;nginx-deployment&quot;, &quot;namespace&quot; =&gt; &quot;default&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 3, &quot;selector&quot; =&gt; %{&quot;matchLabels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; [ %{ &quot;image&quot; =&gt; &quot;nginx:nginx:1.7.9&quot;, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;ports&quot; =&gt; [%{&quot;containerPort&quot; =&gt; 80}] } ] } } } } ]"},{"ref":"K8s.Resource.html#annotation/2","title":"K8s.Resource.annotation/2","type":"function","doc":"Returns the value of a k8s resource&#39;s annotation. Examples iex&gt; K8s.Resource.annotation(%{&quot;metadata&quot; =&gt; %{&quot;annotations&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}, &quot;env&quot;) &quot;test&quot;"},{"ref":"K8s.Resource.html#annotations/1","title":"K8s.Resource.annotations/1","type":"function","doc":"Returns the annotations of k8s resource. Examples iex&gt; K8s.Resource.annotations(%{&quot;metadata&quot; =&gt; %{&quot;annotations&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}) %{&quot;env&quot; =&gt; &quot;test&quot;}"},{"ref":"K8s.Resource.html#api_version/1","title":"K8s.Resource.api_version/1","type":"function","doc":"Returns the apiVersion of k8s resource. Examples iex&gt; K8s.Resource.api_version(%{&quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;}) &quot;apps/v1&quot;"},{"ref":"K8s.Resource.html#build/2","title":"K8s.Resource.build/2","type":"function","doc":"Helper for building a kubernetes&#39; resource Map Examples iex&gt; K8s.Resource.build(&quot;v1&quot;, &quot;Pod&quot;) %{&quot;apiVersion&quot; =&gt; &quot;v1&quot;, &quot;kind&quot; =&gt; &quot;Pod&quot;, &quot;metadata&quot; =&gt; %{}} iex&gt; K8s.Resource.build(&quot;v1&quot;, &quot;Namespace&quot;, &quot;foo&quot;) %{&quot;apiVersion&quot; =&gt; &quot;v1&quot;, &quot;kind&quot; =&gt; &quot;Namespace&quot;, &quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;foo&quot;}} iex&gt; K8s.Resource.build(&quot;v1&quot;, &quot;Pod&quot;, &quot;default&quot;, &quot;foo&quot;) %{&quot;apiVersion&quot; =&gt; &quot;v1&quot;, &quot;kind&quot; =&gt; &quot;Pod&quot;, &quot;metadata&quot; =&gt; %{&quot;namespace&quot; =&gt; &quot;default&quot;, &quot;name&quot; =&gt; &quot;foo&quot;}}"},{"ref":"K8s.Resource.html#build/3","title":"K8s.Resource.build/3","type":"function","doc":""},{"ref":"K8s.Resource.html#build/4","title":"K8s.Resource.build/4","type":"function","doc":""},{"ref":"K8s.Resource.html#cpu/1","title":"K8s.Resource.cpu/1","type":"function","doc":"Deserializes CPU quantity Examples Parses whole values iex&gt; K8s.Resource.cpu(&quot;3&quot;) 3 Parses millicpu values iex&gt; K8s.Resource.cpu(&quot;500m&quot;) 0.5 Parses decimal values iex&gt; K8s.Resource.cpu(&quot;1.5&quot;) 1.5"},{"ref":"K8s.Resource.html#from_file!/2","title":"K8s.Resource.from_file!/2","type":"function","doc":"Create a resource Map from a YAML file. Raises File.Error when the file does not exist. Examples iex&gt; opts = [namespace: &quot;default&quot;, name: &quot;nginx&quot;, image: &quot;nginx:nginx:1.7.9&quot;] ...&gt; K8s.Resource.from_file!(&quot;test/support/deployment.yaml&quot;, opts) %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}, &quot;name&quot; =&gt; &quot;nginx-deployment&quot;, &quot;namespace&quot; =&gt; &quot;default&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 3, &quot;selector&quot; =&gt; %{&quot;matchLabels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; [ %{ &quot;image&quot; =&gt; &quot;nginx:nginx:1.7.9&quot;, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;ports&quot; =&gt; [%{&quot;containerPort&quot; =&gt; 80}] } ] } } } }"},{"ref":"K8s.Resource.html#has_annotation?/2","title":"K8s.Resource.has_annotation?/2","type":"function","doc":"Check if an annotation is present. Examples iex&gt; K8s.Resource.has_annotation?(%{&quot;metadata&quot; =&gt; %{&quot;annotations&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}, &quot;env&quot;) true iex&gt; K8s.Resource.has_annotation?(%{&quot;metadata&quot; =&gt; %{&quot;annotations&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}, &quot;foo&quot;) false"},{"ref":"K8s.Resource.html#has_label?/2","title":"K8s.Resource.has_label?/2","type":"function","doc":"Check if a label is present. Examples iex&gt; K8s.Resource.has_label?(%{&quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}, &quot;env&quot;) true iex&gt; K8s.Resource.has_label?(%{&quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}, &quot;foo&quot;) false"},{"ref":"K8s.Resource.html#kind/1","title":"K8s.Resource.kind/1","type":"function","doc":"Returns the kind of k8s resource. Examples iex&gt; K8s.Resource.kind(%{&quot;kind&quot; =&gt; &quot;Deployment&quot;}) &quot;Deployment&quot;"},{"ref":"K8s.Resource.html#label/2","title":"K8s.Resource.label/2","type":"function","doc":"Returns the value of a k8s resource&#39;s label. Examples iex&gt; K8s.Resource.label(%{&quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}, &quot;env&quot;) &quot;test&quot;"},{"ref":"K8s.Resource.html#labels/1","title":"K8s.Resource.labels/1","type":"function","doc":"Returns the labels of k8s resource. Examples iex&gt; K8s.Resource.labels(%{&quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}) %{&quot;env&quot; =&gt; &quot;test&quot;}"},{"ref":"K8s.Resource.html#memory/1","title":"K8s.Resource.memory/1","type":"function","doc":"Deserializes memory quantity Examples Parses whole values iex&gt; K8s.Resource.memory(&quot;1000000&quot;) 1000000 Parses decimal values iex&gt; K8s.Resource.memory(&quot;10.75&quot;) 10.75 Parses decimalSI values iex&gt; K8s.Resource.memory(&quot;10M&quot;) 10000000 Parses binarySI suffixes iex&gt; K8s.Resource.memory(&quot;50Mi&quot;) 52428800 Returns the numeric value when the suffix is unrecognized iex&gt; K8s.Resource.memory(&quot;50Foo&quot;) 50"},{"ref":"K8s.Resource.html#metadata/1","title":"K8s.Resource.metadata/1","type":"function","doc":"Returns the metadata of k8s resource. Examples iex&gt; K8s.Resource.metadata(%{&quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;foo&quot;}}) %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;foo&quot;}"},{"ref":"K8s.Resource.html#name/1","title":"K8s.Resource.name/1","type":"function","doc":"Returns the name of k8s resource. Examples iex&gt; K8s.Resource.name(%{&quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;foo&quot;}}) &quot;nginx&quot;"},{"ref":"K8s.Resource.html#namespace/1","title":"K8s.Resource.namespace/1","type":"function","doc":"Returns the namespace of k8s resource. Examples iex&gt; K8s.Resource.namespace(%{&quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;foo&quot;}}) &quot;foo&quot;"},{"ref":"K8s.Selector.html","title":"K8s.Selector","type":"module","doc":"Builds label selectors for K8s.Operations Examples Parse from a YAML map iex&gt; deployment = %{ ...&gt; &quot;kind&quot; =&gt; &quot;Deployment&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;tier&quot; =&gt; &quot;backend&quot; ...&gt; } ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;selector&quot; =&gt; %{ ...&gt; &quot;matchLabels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;template&quot; =&gt; %{ ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;tier&quot; =&gt; &quot;backend&quot; ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; K8s.Selector.parse(deployment) %K8s.Selector{match_labels: %{&quot;app&quot; =&gt; &quot;nginx&quot;}} Provides a composable interface for building label selectors iex&gt; {&quot;component&quot;, &quot;redis&quot;} ...&gt; |&gt; K8s.Selector.label() ...&gt; |&gt; K8s.Selector.label_in({&quot;tier&quot;, &quot;cache&quot;}) ...&gt; |&gt; K8s.Selector.label_not_in({&quot;environment&quot;, &quot;dev&quot;}) ...&gt; |&gt; K8s.Selector.label_exists(&quot;foo&quot;) ...&gt; |&gt; K8s.Selector.label_does_not_exist(&quot;bar&quot;) %K8s.Selector{ match_labels: %{&quot;component&quot; =&gt; &quot;redis&quot;}, match_expressions: [ %{&quot;key&quot; =&gt; &quot;tier&quot;, &quot;operator&quot; =&gt; &quot;In&quot;, &quot;values&quot; =&gt; [&quot;cache&quot;]}, %{&quot;key&quot; =&gt; &quot;environment&quot;, &quot;operator&quot; =&gt; &quot;NotIn&quot;, &quot;values&quot; =&gt; [&quot;dev&quot;]}, %{&quot;key&quot; =&gt; &quot;foo&quot;, &quot;operator&quot; =&gt; &quot;Exists&quot;}, %{&quot;key&quot; =&gt; &quot;bar&quot;, &quot;operator&quot; =&gt; &quot;DoesNotExist&quot;} ] } Provides a composable interface for adding selectors to K8s.Operations. iex&gt; K8s.Client.get(&quot;v1&quot;, :pods) ...&gt; |&gt; K8s.Selector.label({&quot;app&quot;, &quot;nginx&quot;}) ...&gt; |&gt; K8s.Selector.label_in({&quot;environment&quot;, [&quot;qa&quot;, &quot;prod&quot;]}) %K8s.Operation{data: nil, api_version: &quot;v1&quot;, label_selector: %K8s.Selector{match_expressions: [%{&quot;key&quot; =&gt; &quot;environment&quot;, &quot;operator&quot; =&gt; &quot;In&quot;, &quot;values&quot; =&gt; [&quot;qa&quot;, &quot;prod&quot;]}], match_labels: %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, method: :get, name: :pods, path_params: [], verb: :get}"},{"ref":"K8s.Selector.html#label/1","title":"K8s.Selector.label/1","type":"function","doc":"matchLabels helper that creates a composable K8s.Selector. Examples iex&gt; K8s.Selector.label({&quot;component&quot;, &quot;redis&quot;}) %K8s.Selector{match_labels: %{&quot;component&quot; =&gt; &quot;redis&quot;}}"},{"ref":"K8s.Selector.html#label/2","title":"K8s.Selector.label/2","type":"function","doc":"matchLabels helper that creates a composable K8s.Selector. Examples iex&gt; selector = K8s.Selector.label({&quot;component&quot;, &quot;redis&quot;}) ...&gt; K8s.Selector.label(selector, {&quot;environment&quot;, &quot;dev&quot;}) %K8s.Selector{match_labels: %{&quot;component&quot; =&gt; &quot;redis&quot;, &quot;environment&quot; =&gt; &quot;dev&quot;}}"},{"ref":"K8s.Selector.html#label_does_not_exist/1","title":"K8s.Selector.label_does_not_exist/1","type":"function","doc":"DoesNotExist expression helper that creates a composable K8s.Selector. Examples iex&gt; K8s.Selector.label_does_not_exist(&quot;environment&quot;) %K8s.Selector{match_expressions: [%{&quot;key&quot; =&gt; &quot;environment&quot;, &quot;operator&quot; =&gt; &quot;DoesNotExist&quot;}]}"},{"ref":"K8s.Selector.html#label_does_not_exist/2","title":"K8s.Selector.label_does_not_exist/2","type":"function","doc":""},{"ref":"K8s.Selector.html#label_exists/1","title":"K8s.Selector.label_exists/1","type":"function","doc":"Exists expression helper that creates a composable K8s.Selector. Examples iex&gt; K8s.Selector.label_exists(&quot;environment&quot;) %K8s.Selector{match_expressions: [%{&quot;key&quot; =&gt; &quot;environment&quot;, &quot;operator&quot; =&gt; &quot;Exists&quot;}]}"},{"ref":"K8s.Selector.html#label_exists/2","title":"K8s.Selector.label_exists/2","type":"function","doc":""},{"ref":"K8s.Selector.html#label_in/1","title":"K8s.Selector.label_in/1","type":"function","doc":"In expression helper that creates a composable K8s.Selector. Examples iex&gt; K8s.Selector.label_in({&quot;component&quot;, &quot;redis&quot;}) %K8s.Selector{match_expressions: [%{&quot;key&quot; =&gt; &quot;component&quot;, &quot;operator&quot; =&gt; &quot;In&quot;, &quot;values&quot; =&gt; [&quot;redis&quot;]}]}"},{"ref":"K8s.Selector.html#label_in/2","title":"K8s.Selector.label_in/2","type":"function","doc":""},{"ref":"K8s.Selector.html#label_not_in/1","title":"K8s.Selector.label_not_in/1","type":"function","doc":"NotIn expression helper that creates a composable K8s.Selector. Examples iex&gt; K8s.Selector.label_not_in({&quot;component&quot;, &quot;redis&quot;}) %K8s.Selector{match_expressions: [%{&quot;key&quot; =&gt; &quot;component&quot;, &quot;operator&quot; =&gt; &quot;NotIn&quot;, &quot;values&quot; =&gt; [&quot;redis&quot;]}]}"},{"ref":"K8s.Selector.html#label_not_in/2","title":"K8s.Selector.label_not_in/2","type":"function","doc":""},{"ref":"K8s.Selector.html#parse/1","title":"K8s.Selector.parse/1","type":"function","doc":"Parses a &quot;selector&quot; map of &quot;matchLabels&quot; and &quot;matchExpressions&quot; Examples iex&gt; selector = %{ ...&gt; &quot;matchLabels&quot; =&gt; %{&quot;component&quot; =&gt; &quot;redis&quot;}, ...&gt; &quot;matchExpressions&quot; =&gt; [ ...&gt; %{&quot;operator&quot; =&gt; &quot;In&quot;, &quot;key&quot; =&gt; &quot;tier&quot;, &quot;values&quot; =&gt; [&quot;cache&quot;]}, ...&gt; %{&quot;operator&quot; =&gt; &quot;NotIn&quot;, &quot;key&quot; =&gt; &quot;environment&quot;, &quot;values&quot; =&gt; [&quot;dev&quot;]} ...&gt; ] ...&gt; } ...&gt; K8s.Selector.parse(selector) %K8s.Selector{match_labels: %{&quot;component&quot; =&gt; &quot;redis&quot;}, match_expressions: [%{&quot;operator&quot; =&gt; &quot;In&quot;, &quot;key&quot; =&gt; &quot;tier&quot;, &quot;values&quot; =&gt; [&quot;cache&quot;]},%{&quot;operator&quot; =&gt; &quot;NotIn&quot;, &quot;key&quot; =&gt; &quot;environment&quot;, &quot;values&quot; =&gt; [&quot;dev&quot;]}]}"},{"ref":"K8s.Selector.html#serialize_match_expressions/1","title":"K8s.Selector.serialize_match_expressions/1","type":"function","doc":"Returns a labelSelector query string value for a set of label expressions. For != matches, use a NotIn set-based expression. Examples Builds a query string for In expressions (kubectl get pods -l &#39;environment in (production,qa),tier in (frontend)): iex&gt; expressions = [ ...&gt; %{&quot;operator&quot; =&gt; &quot;In&quot;, &quot;key&quot; =&gt; &quot;environment&quot;, &quot;values&quot; =&gt; [&quot;production&quot;, &quot;qa&quot;]}, ...&gt; %{&quot;operator&quot; =&gt; &quot;In&quot;, &quot;key&quot; =&gt; &quot;tier&quot;, &quot;values&quot; =&gt; [&quot;frontend&quot;]}, ...&gt; ] ...&gt; K8s.Selector.serialize_match_expressions(expressions) [&quot;environment in (production,qa)&quot;, &quot;tier in (frontend)&quot;] Builds a query string for NotIn expressions (kubectl get pods -l &#39;environment notin (frontend)): iex&gt; expressions = [ ...&gt; %{&quot;operator&quot; =&gt; &quot;NotIn&quot;, &quot;key&quot; =&gt; &quot;environment&quot;, &quot;values&quot; =&gt; [&quot;frontend&quot;]} ...&gt; ] ...&gt; K8s.Selector.serialize_match_expressions(expressions) [&quot;environment notin (frontend)&quot;] Builds a query string for Exists expressions (kubectl get pods -l &#39;environment&#39;): iex&gt; expressions = [ ...&gt; %{&quot;operator&quot; =&gt; &quot;Exists&quot;, &quot;key&quot; =&gt; &quot;environment&quot;} ...&gt; ] ...&gt; K8s.Selector.serialize_match_expressions(expressions) [&quot;environment&quot;] Builds a query string for DoesNotExist expressions (kubectl get pods -l &#39;!environment&#39;): iex&gt; expressions = [ ...&gt; %{&quot;operator&quot; =&gt; &quot;DoesNotExist&quot;, &quot;key&quot; =&gt; &quot;environment&quot;} ...&gt; ] ...&gt; K8s.Selector.serialize_match_expressions(expressions) [&quot;!environment&quot;]"},{"ref":"K8s.Selector.html#serialize_match_labels/1","title":"K8s.Selector.serialize_match_labels/1","type":"function","doc":"Returns a labelSelector query string value for a set of label matches. Examples Builds a query string for a single label (kubectl get pods -l environment=production): iex&gt; K8s.Selector.serialize_match_labels(%{&quot;environment&quot; =&gt; &quot;prod&quot;}) [&quot;environment=prod&quot;] Builds a query string for multiple labels (kubectl get pods -l environment=production,tier=frontend): iex&gt; K8s.Selector.serialize_match_labels(%{&quot;environment&quot; =&gt; &quot;prod&quot;, &quot;tier&quot; =&gt; &quot;frontend&quot;}) [&quot;environment=prod&quot;, &quot;tier=frontend&quot;]"},{"ref":"K8s.Selector.html#to_s/1","title":"K8s.Selector.to_s/1","type":"function","doc":"Serializes a K8s.Selector to a labelSelector query string. Examples iex&gt; selector = K8s.Selector.label({&quot;component&quot;, &quot;redis&quot;}) ...&gt; K8s.Selector.to_s(selector) &quot;component=redis&quot;"},{"ref":"K8s.Selector.html#t:selector_or_operation_t/0","title":"K8s.Selector.selector_or_operation_t/0","type":"type","doc":""},{"ref":"K8s.Selector.html#t:t/0","title":"K8s.Selector.t/0","type":"type","doc":""},{"ref":"K8s.Sys.Event.html","title":"K8s.Sys.Event","type":"module","doc":"K8s.Sys.Event is a thin wrapper around :telemetry. All events will be prefixed with k8s. The following events are emitted: [:k8s, :cluster, :registered] [:k8s, :http, :request, :failed] [:k8s, :http, :request, :succeeded] To access this list programmatically use events/0. If set, default metadata will be applied to all events. See: metadata/0"},{"ref":"K8s.Sys.Event.html#cluster_registered/2","title":"K8s.Sys.Event.cluster_registered/2","type":"function","doc":"When a cluster is successfully registered"},{"ref":"K8s.Sys.Event.html#events/0","title":"K8s.Sys.Event.events/0","type":"function","doc":"Returns a list of all events emitted by this module: [:k8s, :cluster, :registered] [:k8s, :http, :request, :failed] [:k8s, :http, :request, :succeeded] Great for use with :telemetry.attach_many/4"},{"ref":"K8s.Sys.Event.html#http_request_failed/2","title":"K8s.Sys.Event.http_request_failed/2","type":"function","doc":"K8s.Client.HTTPProvider request failed"},{"ref":"K8s.Sys.Event.html#http_request_succeeded/2","title":"K8s.Sys.Event.http_request_succeeded/2","type":"function","doc":"K8s.Client.HTTPProvider request succeeded"},{"ref":"K8s.Sys.Event.html#metadata/0","title":"K8s.Sys.Event.metadata/0","type":"function","doc":"Default metadata added to all events. Defaults: %{}"},{"ref":"K8s.Sys.Event.html#metadata/1","title":"K8s.Sys.Event.metadata/1","type":"function","doc":"Merges metadata with defaults"},{"ref":"K8s.Sys.Event.html#name/0","title":"K8s.Sys.Event.name/0","type":"function","doc":"The instrumenter name"},{"ref":"K8s.Sys.Logger.html","title":"K8s.Sys.Logger","type":"module","doc":"Attaches telemetry events to the Elixir Logger"},{"ref":"K8s.Sys.Logger.html#attach/0","title":"K8s.Sys.Logger.attach/0","type":"function","doc":"Attaches telemetry events to the Elixir Logger"},{"ref":"K8s.Version.html","title":"K8s.Version","type":"module","doc":"Kubernetes API Versioning"},{"ref":"K8s.Version.html#alpha/1","title":"K8s.Version.alpha/1","type":"function","doc":"Returns only alpha versions Examples iex&gt; K8s.Version.alpha([&quot;v1alpha1&quot;, &quot;v1&quot;, &quot;v2beta1&quot;]) [%K8s.Version{major: 1, minor: &quot;alpha&quot;, patch: 1}]"},{"ref":"K8s.Version.html#beta/1","title":"K8s.Version.beta/1","type":"function","doc":"Returns only beta versions Examples iex&gt; K8s.Version.beta([&quot;v1alpha1&quot;, &quot;v1&quot;, &quot;v2beta1&quot;]) [%K8s.Version{major: 2, minor: &quot;beta&quot;, patch: 1}]"},{"ref":"K8s.Version.html#edge/1","title":"K8s.Version.edge/1","type":"function","doc":"Retuns all non-stable versions Examples iex&gt; K8s.Version.edge([&quot;v1alpha1&quot;, &quot;v1&quot;, &quot;v2beta1&quot;]) [%K8s.Version{major: 1, minor: &quot;alpha&quot;, patch: 1}, %K8s.Version{major: 2, minor: &quot;beta&quot;, patch: 1}]"},{"ref":"K8s.Version.html#parse/1","title":"K8s.Version.parse/1","type":"function","doc":"Parses a Kubernetes API version into a K8s.Version struct Examples iex&gt; K8s.Version.parse(&quot;v1&quot;) %K8s.Version{major: 1, minor: &quot;stable&quot;, patch: nil} iex&gt; K8s.Version.parse(&quot;v1beta2&quot;) %K8s.Version{major: 1, minor: &quot;beta&quot;, patch: 2} iex&gt; K8s.Version.parse(&quot;v1alpha1&quot;) %K8s.Version{major: 1, minor: &quot;alpha&quot;, patch: 1}"},{"ref":"K8s.Version.html#recommended/1","title":"K8s.Version.recommended/1","type":"function","doc":"Returns the recommended version from a list of versions. It will return the most stable version if any, otherwise the newest &quot;edge&quot; version. Examples iex&gt; K8s.Version.recommended([&quot;v1beta1&quot;, &quot;v1&quot;, &quot;v2&quot;]) &quot;v2&quot; iex&gt; K8s.Version.recommended([&quot;v1beta1&quot;, &quot;v1&quot;]) &quot;v1&quot; iex&gt; K8s.Version.recommended([&quot;v1beta2&quot;, &quot;v1beta1&quot;]) &quot;v1beta2&quot; iex&gt; K8s.Version.recommended([&quot;v1alpha1&quot;, &quot;v1alpha2&quot;, &quot;v1beta1&quot;]) &quot;v1beta1&quot;"},{"ref":"K8s.Version.html#serialize/1","title":"K8s.Version.serialize/1","type":"function","doc":"Returns only stable versions Examples iex&gt; K8s.Version.serialize(%K8s.Version{major: 1, minor: &quot;stable&quot;, patch: nil}) &quot;v1&quot; iex&gt; K8s.Version.serialize(%K8s.Version{major: 1, minor: &quot;beta&quot;, patch: 1}) &quot;v1beta1&quot; iex&gt; K8s.Version.serialize(%K8s.Version{major: 1, minor: &quot;alpha&quot;, patch: 1}) &quot;v1alpha1&quot;"},{"ref":"K8s.Version.html#sort/1","title":"K8s.Version.sort/1","type":"function","doc":"Sorts a list of K8s.Versions Examples iex&gt; raw_versions = Enum.shuffle([&quot;v1&quot;, &quot;v2beta1&quot;, &quot;v2&quot;, &quot;v1alpha1&quot;, &quot;v1alpha2&quot;]) iex&gt; versions = raw_versions |&gt; Enum.map(&amp;(K8s.Version.parse(&amp;1))) iex&gt; sorted_versions = versions |&gt; K8s.Version.sort() iex&gt; sorted_versions |&gt; Enum.map(&amp;(K8s.Version.serialize(&amp;1))) [&quot;v2&quot;, &quot;v1&quot;, &quot;v2beta1&quot;, &quot;v1alpha2&quot;, &quot;v1alpha1&quot;]"},{"ref":"K8s.Version.html#stable/1","title":"K8s.Version.stable/1","type":"function","doc":"Returns only stable versions Examples iex&gt; K8s.Version.stable([&quot;v1alpha1&quot;, &quot;v1&quot;, &quot;v2beta1&quot;]) [%K8s.Version{major: 1, minor: &quot;stable&quot;, patch: nil}]"},{"ref":"K8s.Version.html#t:t/0","title":"K8s.Version.t/0","type":"type","doc":""},{"ref":"readme.html","title":"K8s","type":"extras","doc":"K8s K8s - Kubernetes API Client for Elixir"},{"ref":"readme.html#features","title":"K8s - Features","type":"extras","doc":"A client API for humans Kubernetes resources, groups, and CRDs are autodiscovered at boot time. No swagger file to include or override. Client supports standard HTTP calls, async batches, wait on status, and watchers Supports multiple clusters Supports multiple authentication credentials serviceaccount token certificate auth-provider Supports multiple kubernetes API Tested against kubernetes swagger specs: 1.10+ and master CRD support Kubernetes resource and version helper functions Kube config file parsing Certificate and service account based auth Pluggable auth providers Macro free; fast compile &amp; fast startup"},{"ref":"readme.html#installation","title":"K8s - Installation","type":"extras","doc":"The package can be installed by adding k8s to your list of dependencies in mix.exs: def deps do [ {:k8s, &quot;~&gt; 0.2&quot;} ] end"},{"ref":"readme.html#usage","title":"K8s - Usage","type":"extras","doc":"Check out the Usage Guide for in-depth examples. Most functions are also written using doctests. K8s.Client doctests K8s.Cluster doctests K8s.Conf doctests K8s.Resource doctests K8s.Version doctests"},{"ref":"readme.html#testing-k8s-operations-in-your-application","title":"K8s - Testing K8s operations in your application","type":"extras","doc":"K8s ships with a K8s.Client.DynamicHTTPProvider for stubbing HTTP responses to kubernetes API requests. This provider is used throughout the test suite for mocking HTTP responses. defmodule MyApp.ResourceTest do use ExUnit.Case, async: true defmodule K8sMock do @base_url &quot;https://localhost:6443&quot; @namespaces_url @base_url &lt;&gt; &quot;/api/v1/namespaces&quot; def request(:get, @namespaces_url, _, _, _) do namespaces = [%{&quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;default&quot;}}] body = Jason.encode!(namespaces) {:ok, %HTTPoison.Response{status_code: 200, body: body}} end end setup do DynamicHTTPProvider.register(self(), __MODULE__.K8sMock) end test &quot;gets namespaces&quot; do operation = K8s.Client.get(&quot;v1&quot;, :namespaces) assert {:ok, namespaces} = K8s.Client.run(operation, :default) assert namespaces == [%{&quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;default&quot;}}] end end To see advanced examples of usage, check out these examples in the test suite: client/runner/base client/runner/stream client/runner/watch discovery"},{"ref":"readme.html#contributing","title":"K8s - Contributing","type":"extras","doc":"Adding support for a new version of kubernetes Download the swagger spec for the new version. k8s doesn&#39;t use swagger to define the API, but it is used to drive property tests. export NEW_VERSION_NUMBER=1.1n make get/${NEW_VERSION_NUMBER} make test/${NEW_VERSION_NUMBER} Mock discovery responses exist to simulate runtime API discovery using the FileDriver If new resources or APIs were added to kubernetes in the new version you will likely see one of these errors: unsupported_api_version and unsupported_resource. Unsupported API Version errors This error occurs when a new API is added to kubernetes. Example: {:error, :unsupported_api_version, &quot;scheduling.k8s.io/v1&quot;} Add the :unsupported_api_version to this mock configuration and rerun the test suite. A config entry looks like: // ... { &quot;groupVersion&quot;: &quot;scheduling.k8s.io/v1&quot;, // add the api version &quot;kind&quot;: &quot;APIResourceList&quot;, // leave as is &quot;resources&quot;: [ // add a list of resources provided by the new `groupVersion` { &quot;kind&quot;: &quot;PriorityClass&quot;, // `kind` name &quot;name&quot;: &quot;priorityclasses&quot;, // plural name &quot;namespaced&quot;: false, // namespaced or not &quot;singularName&quot;: &quot;&quot;, &quot;verbs&quot;: [ // list of verbs supported by the new API &quot;create&quot;, &quot;delete&quot;, &quot;deletecollection&quot;, &quot;get&quot;, &quot;list&quot;, &quot;patch&quot;, &quot;update&quot;, &quot;watch&quot; ] } ] }, // ... Unsupported Resource errors This error occurs when a new resource type is added to an existing API, similar to above you will need to add the resource to the list of resources. The following config is missing runtimeclasses as a resource. { &quot;groupVersion&quot;: &quot;node.k8s.io/v1beta1&quot;, &quot;kind&quot;: &quot;APIResourceList&quot;, &quot;resources&quot;: [ { &quot;kind&quot;: &quot;Node&quot;, &quot;name&quot;: &quot;nodes&quot;, &quot;namespaced&quot;: false, &quot;singularName&quot;: &quot;&quot;, &quot;verbs&quot;: [ &quot;create&quot;, &quot;delete&quot;, &quot;deletecollection&quot;, &quot;get&quot;, &quot;list&quot;, &quot;patch&quot;, &quot;update&quot;, &quot;watch&quot; ] } ] }, After mocking: { &quot;groupVersion&quot;: &quot;node.k8s.io/v1beta1&quot;, &quot;kind&quot;: &quot;APIResourceList&quot;, &quot;resources&quot;: [ { &quot;kind&quot;: &quot;Node&quot;, &quot;name&quot;: &quot;nodes&quot;, &quot;namespaced&quot;: false, &quot;singularName&quot;: &quot;&quot;, &quot;verbs&quot;: [ &quot;create&quot;, &quot;delete&quot;, &quot;deletecollection&quot;, &quot;get&quot;, &quot;list&quot;, &quot;patch&quot;, &quot;update&quot;, &quot;watch&quot; ] }, { &quot;kind&quot;: &quot;RuntimeClass&quot;, &quot;name&quot;: &quot;runtimeclasses&quot;, &quot;namespaced&quot;: false, &quot;singularName&quot;: &quot;&quot;, &quot;verbs&quot;: [ &quot;create&quot;, &quot;delete&quot;, &quot;deletecollection&quot;, &quot;get&quot;, &quot;list&quot;, &quot;patch&quot;, &quot;update&quot;, &quot;watch&quot; ] } ] },"},{"ref":"usage.html","title":"Usage","type":"extras","doc":"Usage"},{"ref":"usage.html#registering-clusters","title":"Usage - Registering Clusters","type":"extras","doc":"Clusters can be registered via config.exs or directly with K8s.Cluster.Registry.add/2. Clusters are referenced by name (:default below) when using a K8s.Client. Multiple clusters can be registered via config or at runtime. Kubernetes API resources are auto-discovered at boot time. This library is currently tested against k8s OpenAPI specs: 1.1x and master. Registering Clusters at Run Time The below will register a cluster named :prod using ~/.kube.config to connect. There are many options for loading a config, this will load the user and cluster from the current-context. conf = K8s.Conf.from_file(&quot;~/.kube/config&quot;) K8s.Cluster.Registry.add(:prod, conf) Registering a cluster using the k8s&#39; ServiceAccount of the pod: conf = K8s.Conf.from_service_account() K8s.Cluster.Registry.add(:prod, conf) Registering Clusters at Compile Time (config.exs) Adding a cluster named :default using ~/.kube/config. Defaults to current-context of the kube config file. config :k8s, clusters: %{ default: %{ conf: &quot;~/.kube/config&quot; } } Using an alternate context: config :k8s, clusters: %{ default: %{ conf: &quot;~/.kube/config&quot; conf_opts: [context: &quot;other-context&quot;] } } Setting cluster and user explicitly: config :k8s, clusters: %{ default: %{ conf: &quot;~/.kube/config&quot; conf_opts: [user: &quot;some-user&quot;, cluster: &quot;prod-cluster&quot;] } } Using a pod&#39;s service account (pod.spec.serviceAccountName): A cluster name with a blank configuration will default to using the pod&#39;s service account. config :k8s, clusters: %{ default: %{} } Registering Clusters with Environment Variables Multiple clusters can be registered via environment variables. Keep in mind that under the hood, k8s uses kubeconfig files. Environment Variable Prefixes: K8S_CLUSTER_CONF_SA_ - boolean enables authentication to the k8s API with the pods spec.serviceAccount. K8S_CLUSTER_CONF_PATH_ - string absolute path to the kube config file. K8S_CLUSTER_CONF_CONTEXT_ string which context to use in the kube config file. Examples: Configure access to a cluster named us_central to use the pod&#39;s service account: export K8S_CLUSTER_CONF_SA_us_central=true Set the path to a kubeconfig file and the context to use for us_east: export K8S_CLUSTER_CONF_PATH_us_east=&quot;east.yaml&quot; export K8S_CLUSTER_CONF_CONTEXT_us_east=&quot;east&quot; Register multiple clusters: export K8S_CLUSTER_CONF_SA_us_central=true export K8S_CLUSTER_CONF_PATH_us_east=&quot;east.yaml&quot; export K8S_CLUSTER_CONF_CONTEXT_us_east=&quot;east&quot; export K8S_CLUSTER_CONF_PATH_us_west=&quot;west.yaml&quot; export K8S_CLUSTER_CONF_CONTEXT_us_west=&quot;west&quot;"},{"ref":"usage.html#running-an-operation","title":"Usage - Running an operation","type":"extras","doc":"Many more client examples exist in the K8s.Client docs. Creating a Deployment from a Map resource = %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}, &quot;name&quot; =&gt; &quot;nginx-deployment&quot;, &quot;namespace&quot; =&gt; &quot;default&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 3, &quot;selector&quot; =&gt; %{&quot;matchLabels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; [ %{ &quot;image&quot; =&gt; &quot;nginx:1.7.9&quot;, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;ports&quot; =&gt; [%{&quot;containerPort&quot; =&gt; 80}] } ] } } } } operation = K8s.Client.create(resource) {:ok, response} = K8s.Client.run(operation, :dev) Creating a Deployment from a YAML file Given the YAML file priv/deployment.yaml: apiVersion: apps/v1 kind: Deployment metadata: name: &lt;%= name %&gt;-deployment namespace: &lt;%= namespace %&gt; labels: app: &lt;%= name %&gt; spec: replicas: 3 selector: matchLabels: app: &lt;%= name %&gt; template: metadata: labels: app: &lt;%= name %&gt; spec: containers: - name: &lt;%= name %&gt; image: &lt;%= image %&gt; ports: - containerPort: 80 opts = [namespace: &quot;default&quot;, name: &quot;nginx&quot;, image: &quot;nginx:nginx:1.7.9&quot;] resource = K8s.Resource.from_file!(&quot;priv/deployment.yaml&quot;, opts) operation = K8s.Client.create(resource) {:ok, deployment} = K8s.Client.run(operation, :dev) Listing Deployments In a given namespace: operation = K8s.Client.list(&quot;apps/v1&quot;, &quot;Deployment&quot;, namespace: &quot;prod&quot;) {:ok, deployments} = K8s.Client.run(operation, :dev) Across all namespaces: operation = K8s.Client.list(&quot;apps/v1&quot;, &quot;Deployment&quot;, namespace: :all) {:ok, deployments} = K8s.Client.run(operation, :dev) Note: K8s.Client.list will return a map. The list of resources will be under &quot;items&quot;. Using labelSelector with list operations K8s.Client.list(&quot;apps/v1&quot;, :deployments) |&gt; K8s.Selector.label({&quot;app&quot;, &quot;nginx&quot;}) |&gt; K8s.Selector.label_in({&quot;environment&quot;, [&quot;qa&quot;, &quot;prod&quot;]}) |&gt; K8s.Client.run(:default) Getting a Deployment operation = K8s.Client.get(&quot;apps/v1&quot;, :deployment, [namespace: &quot;default&quot;, name: &quot;nginx-deployment&quot;]) {:ok, deployment} = K8s.Client.run(operation, :dev)"},{"ref":"usage.html#watch-operations","title":"Usage - Watch Operations","type":"extras","doc":"operation = K8s.Client.list(&quot;apps/v1&quot;, :deployment, namespace: :all) {:ok, reference} = K8s.Client.watch(operation, :dev, stream_to: self()) Kubernetes Watch API added, modified, and deleted events will be streamed as they occur."},{"ref":"usage.html#wait-on-a-resource","title":"Usage - Wait on a Resource","type":"extras","doc":"This will wait 60 seconds for the field status.succeeded to equal 1. :find and :eval also accept functions to apply to check success. operation = K8s.Client.get(&quot;batch/v1&quot;, :job, namespace: &quot;default&quot;, name: &quot;database-migrator&quot;) wait_opts = [find: [&quot;status&quot;, &quot;succeeded&quot;], eval: 1, timeout: 60] {:ok, job} = K8s.Client.wait(op, cluster_name, wait_opts)"},{"ref":"usage.html#batch-operations","title":"Usage - Batch Operations","type":"extras","doc":"Fetching two pods at once. operation1 = K8s.Client.get(&quot;v1&quot;, &quot;Pod&quot;, namespace: &quot;default&quot;, name: &quot;pod-1&quot;) operation2 = K8s.Client.get(&quot;v1&quot;, &quot;Pod&quot;, namespace: &quot;default&quot;, name: &quot;pod-2&quot;) # results will be a list of :ok and :error tuples results = K8s.Client.async([operation1, operation2], :dev) Note: all operations are fired async and their results are returned. Processing does not halt if an error occurs for one operation."},{"ref":"usage.html#list-operations-as-a-elixir-streams","title":"Usage - List operations as a Elixir Streams","type":"extras","doc":"operation = K8s.Client.list(&quot;v1&quot;, &quot;Pod&quot;, namespace: :all) operation |&gt; K8s.Client.stream() |&gt; Stream.filter(&amp;my_filter_function?/1) |&gt; Stream.map(&amp;my_map_function?/1) |&gt; Enum.into([])"},{"ref":"usage.html#custom-resource-definitions","title":"Usage - Custom Resource Definitions","type":"extras","doc":"Custom resources are discovered via the same mechanism as &quot;standard&quot; k8s resources and can be worked with as such: Listing the Greetings from the hello operator. operation = K8s.Client.list(&quot;hello-operator.example.com/v1&quot;, :greeting, [namespace: &quot;default&quot;]) {:ok, greeting} = K8s.Client.run(operation, :dev)"},{"ref":"usage.html#multiple-clusters","title":"Usage - Multiple Clusters","type":"extras","doc":"Copying a workloads between two clusters: Register a staging cluster: staging_conf = K8s.Conf.from_file(&quot;~/.kube/config&quot;) {:ok, staging} = K8s.Cluster.Registry.add(:staging, staging_conf) Register a prod cluster: prod_conf = K8s.Conf.from_service_account() # or from_file/2 {:ok, prod} = K8s.Cluster.Registry.add(:prod, staging_conf) Get a list of all deployments in the default prod namespace: operation = K8s.Client.list(&quot;apps/v1&quot;, :deployment, namespace: &quot;default&quot;) {:ok, deployments} = K8s.Client.run(operation, :prod) Map the deployments to operations and async create on staging: deployments |&gt; Enum.map(fn(deployment) -&gt; K8s.Client.create(deployment) end) |&gt; K8s.Client.async(:staging)"},{"ref":"usage.html#adding-authorization-providers","title":"Usage - Adding Authorization Providers","type":"extras","doc":"config :k8s, auth_providers: [My.Custom.Provider] Providers are checked in order, the first to return an authorization struct wins. Custom providers are processed before default providers. For protocol and behavior implementation examples check out Certificate, Token, or AuthProvider here."},{"ref":"usage.html#performing-sub-resource-operations","title":"Usage - Performing sub-resource operations","type":"extras","doc":"Subresource (eviction|finalize|bindings|binding|approval|scale|status) operations are created in the same way as standard operations using K8s.Operation.build/4, K8s.Operation.build/5, or any K8s.Client function. Getting a deployment&#39;s status: cluster = :test operation = K8s.Client.get(&quot;apps/v1&quot;, &quot;deployments/status&quot;, name: &quot;nginx&quot;, namespace: &quot;default&quot;) {:ok, scale} = K8s.Client.run(operation, cluster) Getting a deployment&#39;s scale: cluster = :test operation = K8s.Client.get(&quot;apps/v1&quot;, &quot;deployments/scale&quot;, [name: &quot;nginx&quot;, namespace: &quot;default&quot;]) {:ok, scale} = K8s.Client.run(operation, cluster) There are two forms for mutating subresources. Evicting a pod with a Pod map: cluster = :test eviction = %{ &quot;apiVersion&quot; =&gt; &quot;policy/v1beta1&quot;, &quot;kind&quot; =&gt; &quot;Eviction&quot;, &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;nginx&quot;, } } # Here we use K8s.Resource.build/4 but this k8s resource map could be built manually or retrieved from the k8s API subject = K8s.Resource.build(&quot;v1&quot;, &quot;Pod&quot;, &quot;default&quot;, &quot;nginx&quot;) operation = K8s.Client.create(subject, eviction) {:ok, resp} = K8s.Client.run(operation, cluster) Evicting a pod by providing details: cluster = :test eviction = %{ &quot;apiVersion&quot; =&gt; &quot;policy/v1beta1&quot;, &quot;kind&quot; =&gt; &quot;Eviction&quot;, &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;nginx&quot;, } } subject = K8s.Client.create(&quot;v1&quot;, &quot;pods/eviction&quot;, [namespace: &quot;default&quot;, name: &quot;nginx&quot;], eviction) operation = K8s.Client.create(subject, eviction) {:ok, resp} = K8s.Client.run(operation, cluster)"}]